import pygame
import sys
import random


# Spielfenster
WIDTH = 900
HEIGHT = 500
WIN = pygame.display.set_mode((WIDTH, HEIGHT))
pygame.display.set_caption("Pong in Python")

# Farben als Konstanten
WHITE = (255, 255, 255)
BLACK = (0, 0, 0)
RED = (255, 0, 0)

# Konstanten
FPS = 60

# Score mit Fonts ausgeben
pygame.font.init()
SCORE_FONT = pygame.font.SysFont('impact', 40)
WINNER_FONT = pygame.font.SysFont('impact', 100)

# 1. Spielerscore als Gameevents
PLAYER_ONE_SCORES = pygame.USEREVENT + 1
PLAYER_TWO_SCORES = pygame.USEREVENT + 2


# Spieler
PLAYER_WIDTH = 10
PLAYER_HEIGHT = 100
player_one = pygame.Rect(30, 200, PLAYER_WIDTH, PLAYER_HEIGHT)
player_two = pygame.Rect(860, 200, PLAYER_WIDTH, PLAYER_HEIGHT)
PLAYER_VELOLCITY = 5
# Spielerscore
player_one_score = 0
player_two_score = 0


# Ball
BALL_WIDTH = 10
BALL_HEIGHT = 10
ball = pygame.Rect(445, 245, BALL_WIDTH, BALL_HEIGHT)
ball_velocity_x = 5
ball_velocity_y = 5


def ball_movement():
    global ball_velocity_x, ball_velocity_y
    # Hoch und Runter Bewegung
    ball.y += ball_velocity_y
    # Ball bounce Oben und Unten
    if ball.y + ball_velocity_y < 0 or ball.y + ball_velocity_y > HEIGHT:
        ball_velocity_y = -ball_velocity_y
    # Rechts und Links Bewegung
    ball.x += ball_velocity_x
    # Ball bounce mit Spielern
    if ball.colliderect(player_one) or ball.colliderect(player_two):
        ball_velocity_x = -ball_velocity_x

    # Spielfeld reseten
    if ball.x < 0:
        # Links raus
        # 2. Score mit Spielevents ermitteln
        pygame.event.post(pygame.event.Event(PLAYER_TWO_SCORES))
        reset_player_ball()
    elif ball.x > WIDTH:
        # Rechts raus
        pygame.event.post(pygame.event.Event(PLAYER_ONE_SCORES))
        reset_player_ball()


def reset_player_ball():
    global ball_velocity_x, ball_velocity_y
    # Spieler reseten
    player_one.y = 200
    player_two.y = 200
    # Ball reseten
    ball.x = 445
    ball.y = 245
    # Ballbewegung Random
    velocity = list(range(-5, 6))
    velocity.remove(0)
    # remove = [-2,-1,0,1,2]
    # for r in remove:
    #     velocity.remove(r)
    ball_velocity_x = random.choice(velocity)
    ball_velocity_y = random.choice(velocity)


def player_movement(keys_pressed):
    # Hoch
    if keys_pressed[pygame.K_w] and player_one.y - PLAYER_VELOLCITY > 0:
        player_one.y -= PLAYER_VELOLCITY
    if keys_pressed[pygame.K_UP] and player_two.y - PLAYER_VELOLCITY > 0:
        player_two.y -= PLAYER_VELOLCITY
    # Runter
    if keys_pressed[pygame.K_s] and player_one.y + PLAYER_VELOLCITY + player_one.height < HEIGHT:
        player_one.y += PLAYER_VELOLCITY
    if keys_pressed[pygame.K_DOWN] and player_two.y + PLAYER_VELOLCITY + player_two.height < HEIGHT:
        player_two.y += PLAYER_VELOLCITY


def draw_window():
    WIN.fill(BLACK)
    # Text im Fenster malen
    player_one_score_text = SCORE_FONT.render(str(player_one_score), True, WHITE)
    WIN.blit(player_one_score_text, (10, 10))
    player_two_score_text = SCORE_FONT.render(str(player_two_score), True, WHITE)
    WIN.blit(player_two_score_text, (WIDTH - player_two_score_text.get_width() - 10, 10))

    # Spieler auf Spielfend malen
    pygame.draw.rect(WIN, WHITE, player_one)
    pygame.draw.rect(WIN, WHITE, player_two)
    # Ball auf Spielfend malen
    pygame.draw.rect(WIN, WHITE, ball)
    pygame.display.update()

# Gewinner als Text erscheinen lassen und Spiel nach 5 Sekunden neu starten
def draw_winner_reset_game(text):
    draw_text = WINNER_FONT.render(text, 1, WHITE)
    WIN.blit(draw_text, (WIDTH / 2 - draw_text.get_width() // 2, HEIGHT // 2 - draw_text.get_height() / 2))
    pygame.display.update()
    pygame.time.delay(5000)
    main()

def main():
    global player_one_score, player_two_score
    clock = pygame.time.Clock()
    run = True
    while run:
        # Spielfenster wird 60 mal pro Sekunde neugeladen (60 FPS)
        clock.tick(FPS)

        # Fenster schließen
        for event in pygame.event.get():
            # Spiel wird geschlossen wenn "X" oben rechts geklickt wird
            if event.type == pygame.QUIT:
                run = False
                pygame.quit()
                sys.exit()

            # Spielerscore in Events erkennen
            if event.type == PLAYER_TWO_SCORES:
                player_two_score += 1

            if event.type == PLAYER_ONE_SCORES:
                player_one_score += 1


        # Spieler durch Tasten bewegen
        keys_pressed = pygame.key.get_pressed()
        player_movement(keys_pressed)

        # Ball bewegen
        ball_movement()

        # bei einem Score von 10 den Spieler auslesen und den loop beenden
        if player_one_score == 10:
            draw_winner_reset_game("Player One won!")
            break
        elif player_two_score == 10:
            draw_winner_reset_game("Player Two won!")
            break

        # Spielfenster wird befüllt
        draw_window()


main()
